app/user/forms.py
# -*- coding:utf8 -*-
'''
User Form.
'''
from flask.ext.wtf import Form
from wtforms import StringField, PasswordField, BooleanField, SubmitField, TextAreaField, SelectField
from wtforms.validators import Required, Length, Email, Regexp, EqualTo, ValidationError
from ..models import User, Role

class EditProfileForm(Form):
    name = StringField('真实姓名', validators=[Required(), Length(1, 64, '长度必须为1-64。')])
    location = StringField('居住地', validators=[Required(), Length(1, 64, '长度必须为1-64。')])
    about_me = TextAreaField('关于我')
    submit = SubmitField('提交')

class EditProfileAdminForm(Form):
    email = StringField('邮箱', validators=[Required(), Length(1, 64, '长度必须为1-64。'), Email()])
    username = StringField('用户名', validators=[
        Required(), Length(1, 64, '长度必须为1-64。'), Regexp('^[A-Z][A-Za-z0-9_.]*$', 0,
                                          '用户名第一个字母必须大写，且只能由字母，'
                                          '数字，下划线，点组成。')])
    password = StringField('密码', validators=[
        Required(), Length(1, 16, '长度必须为1-16。'), Regexp('^[A-Za-z0-9_.]*$', 0,
                                          '密码第只能由字母，数字，下划线，点组成。')])
    name = StringField('真实姓名', validators=[Length(0, 64, '长度必须为1-64。')])
    confirmed = BooleanField('是否验证')
    location = StringField('居住地', validators=[Length(0, 64, '长度必须为1-64。')])
    about_me = TextAreaField('关于我')
    # 选择角色
    role = SelectField('角色', coerce=int)
    submit = SubmitField('修改')

    def __init__(self, user, *args, **kwargs):
        super(EditProfileAdminForm, self).__init__(*args, **kwargs)
        self.role.choices = [(role.id, role.name) for role in Role.query.order_by(Role.name).all()]
        self.user = user

    def validate_email(self, filed):
        if self.user.email == filed.data:
            return
        else:
            raise ValidationError('暂时不支持修改邮箱地址！')

    def validate_username(self, filed):
        # 允许管理员修改 用户名，但是不能修改邮箱
        if self.user.username == filed.data:
            return
        if User.query.filter_by(username=filed.data).first():
            raise ValidationError('改用户名已被占用。')

app/user/__init__.py
# -*- coding:utf8 -*-
'''
index page.
'''
__all__ = []
__version__ = '0.0.1'
__author__ = 'GalaIO'

from flask import Blueprint
import app

# 通过实例化一个 Blueprint 类对象可以创建蓝本。
user = Blueprint('user', __name__)
# 动态加载到app的路由链表中
app.fetchRoute(user, '/user')

from . import views

app/user/views.py
# -*- coding:utf8 -*-
'''
index route.
'''
from flask import render_template, redirect, url_for, abort, flash, request, current_app
from . import user
from ..models import User, Role, Post, Permission
from flask.ext.login import login_required, current_user
from .forms import EditProfileForm, EditProfileAdminForm
from .. import db
from .. import messages
from ..decorators import admin_required, permission_required

# 定义路由函数
@user.route('/<username>', methods=['GET', 'POST'])
def profile(username):
    tmp_user = User.query.filter_by(username=username).first()
    if tmp_user is None:
        abort(404)
    page = request.args.get('page', 1, type=int)
    pagination = tmp_user.posts.order_by(Post.timestamp.desc()).paginate(
        page, per_page=current_app.config['POSTS_PER_PAGE'],
        error_out=False)
    posts = pagination.items
    return render_template('user/user.html', user=tmp_user, posts=posts, pagination=pagination)

# 用户编辑资料页
@user.route('/edit', methods=['GET', 'POST'])
@login_required
def edit():
    form = EditProfileForm()
    if form.validate_on_submit():
        current_user.name = form.name.data
        current_user.location = form.location.data
        current_user.about_me = form.about_me.data
        db.session.add(current_user)
        flash(messages.update_profile_ok)
        return redirect(url_for('user.profile', username=current_user.username))
    form.about_me.data = current_user.about_me
    form.location.data = current_user.location
    form.name.data = current_user.name
    return render_template('user/edit.html', form=form)

# 直接索引用户资料页，同时需要管理员权限
@user.route('/edit/<int:id>', methods=['GET', 'POST'])
@login_required
@admin_required
def edit_admin(id):
    user = User.query.get_or_404(id)
    form = EditProfileAdminForm(user)
    if form.validate_on_submit():
        # 不能修改邮件
        # user.email = form.email.data
        user.username = form.username.data
        user.confirmed = form.confirmed.data
        user.role = Role.query.get(form.role.data)
        user.name = form.name.data
        user.location = form.location.data
        user.about_me = form.about_me.data
        db.session.add(user)
        flash(messages.update_profile_ok)
        return redirect(url_for('user.profile', username=user.username))
    form.email.data = user.email
    form.username.data = user.username
    form.confirmed.data = user.confirmed
    form.role.data = user.role_id
    form.name.data = user.name
    form.location.data = user.location
    form.about_me.data = user.about_me
    return render_template('user/edit.html', form=form, user=user)

@user.route('/follow/<username>')
@login_required
@permission_required(Permission.FOLLOW)
def follow(username):
    if current_user.username == username:
        flash(messages.follow_youself_err)
        return redirect(url_for('user.profile', username=username))
    user = User.query.filter_by(username=username).first()
    if user is None:
        flash(messages.user_not_found)
        return redirect('main.index')
    if current_user.is_following(user):
        flash(messages.follow_again_err)
        return redirect(url_for('user.profile', username=username))
    # 过滤完成，允许关注
    current_user.follow(user)
    flash(messages.follow_ok)
    return redirect(url_for('user.profile', username=username))

@user.route('/unfollow/<username>')
@login_required
@permission_required(Permission.FOLLOW)
def unfollow(username):
    if current_user.username == username:
        flash(messages.unfollow_youself_err)
        return redirect(url_for('user.profile', username=username))
    user = User.query.filter_by(username=username).first()
    if user is None:
        flash(messages.user_not_found)
        return redirect('main.index')
    if not current_user.is_following(user):
        flash(messages.unfollow_again_err)
        return redirect(url_for('user.profile', username=username))
    # 过滤完成，允许取消关注
    current_user.unfollow(user)
    flash(messages.unfollow_ok)
    return redirect(url_for('user.profile', username=username))

@user.route('/manage')
@login_required
@permission_required(Permission.MODERATE_USERS)
def manage():
    page = request.args.get('page', 1, type=int)
    pagination = User.query.order_by(User.last_seen.desc()).paginate(
        page, per_page=current_app.config['USERS_PER_PAGE'],
        error_out=False)
    users = pagination.items
    return render_template('user/manage.html', users=users, pagination=pagination)


@user.route('/delete/<username>')
@login_required
@permission_required(Permission.MODERATE_USERS)
def delete(username):
    u = User.query.filter_by(username=username).first()
    if u is None:
        flash(messages.user_not_found)
    else:
        # 依次删除用户及其文章，否则文章会存在空用户索引
        posts = u.posts.all()
        for post in posts:
            db.session.delete(post)
        db.session.delete(u)
    return redirect(url_for('user.manage'))

app/templates/user/_users.html
    <ul class="posts">
        {% for user in users %}
        <li class="post">
            <div class="profile-thumbnail"  width="40px" height="40px">
                <a href="{{ url_for('user.profile', username=user.username) }}">
                    <img class="img-rounded profile-thumbnail" src="{{ user.avatar_url_auto(size=40) }}">
                </a>
            </div>
            <div class="post-content">
                <div class="post-date">{{ moment(user.last_seen).fromNow() }}</div>
                <div class="post-author">
                    <a href="{{ url_for('user.profile', username=user.username) }}">
                    {{ user.username }}
                    </a>
                </div>
                <div class="post-body">
                    <p>
                    <a href="#{# {{ url_for('user.followers', username=user.username) }} #}">
                        博客数量： <span class="badge">{{ user.posts.count() }}</span>
                    </a>|
                    <a href="#{# {{ url_for('user.followers', username=user.username) }} #}">
                        被关注：<span class="badge">{{ user.followers.count() }}</span>
                    </a>|
                    <a href="#{# {{ url_for('user.followed_by', username=user.username) }} #}">
                        关注人数：<span class="badge">{{ user.followed.count() }}</span>
                    </a>
                    </p>
                </div>
                <div class="post-footer">
                    <a href="{{ url_for('user.delete', username=user.username) }}">
                        <span class="label label-danger">删除该用户</span>
                    </a>
                </div>
            </div>
        </li>
        {% endfor %}
    </ul>

app/templates/user/edit.html
{% extends "base.html" %}
{% import "bootstrap/wtf.html" as wtf %}

{% block title %}GalaCoding - 编辑资料页{% endblock %}

{% block page_content %}
<div class="page-header">
    <h1>编辑资料页</h1>
</div>
<div class="col-md-4">
    {{ wtf.quick_form(form) }}
</div>
{% endblock %}

app/templates/user/manage.html
{% extends "base.html" %}
{% import "_macros.html" as macros %}

{% block title %}GalaCoding{% endblock %}

{% block page_content %}
<div class="page-header">
    <h1>
        用户列表
    </h1>
</div>
<div>
    {% include 'user/_users.html' %}
    <div class="pagination">
        {{ macros.pagination_widget(pagination, 'main.index') }}
    </div>
</div>
{% endblock %}

app/templates/user/user.html
{% extends "base.html" %}
{% import "_macros.html" as macros %}

{% block title %}GalaCoding - 用户资料{% endblock %}

{% block page_content %}
<div class="page-header">
    <h1>{{ user.username }}</h1>
    <p>
        {% if current_user.is_authenticated and user == current_user%}
        <a href="{{ url_for('user.edit') }}">编辑</a>
        {% endif %}
    </p>
    <div>
        <img class="img-rounded profile-thumbnail" width="256px" height="256px" src="{{ user.avatar_url_auto(size=256) }}">
        <div class="profile-header">
            {% if user.name or user.location %}
            <p>
                {% if user.name %}真实姓名： {{ user.name }}{% endif %}<br/>
                {% if user.location %}
                来自：{{ user.location }}<br/>
                {% endif %}
            </p>
            {% endif %}
            {% if current_user.is_administrator() %}
            <p>
                管理员邮箱：<a href="mailto:{{ user.email }}">{{ user.email }}</a>
            </p>
            {% endif %}
            {% if user.about_me %}<p>关于我：{{ user.about_me }}</p>{% endif %}<br/>
            <p>
                登录时间： {{ moment(user.member_since).format('LLLL') }}<br/>
                上次登录时间： {{ moment(user.last_seen).fromNow() }}
            </p>

            <p>
                {% if current_user.can(Permission.FOLLOW) and user != current_user %}
                    {% if not current_user.is_following(user) %}
                        <a href="{{ url_for('user.follow', username=user.username) }}"
                        class="btn btn-primary">关注</a>
                    {% else %}
                        <a href="{{ url_for('user.unfollow', username=user.username) }}"
                        class="btn btn-danger">取消关注</a>
                    {% endif %}
                {% endif %}
                <a href="#{# {{ url_for('user.followers', username=user.username) }} #}">
                    博客数量： <span class="badge">{{ user.posts.count() }}</span>
                </a>|
                <a href="#{# {{ url_for('user.followers', username=user.username) }} #}">
                    被关注：<span class="badge">{{ user.followers.count() }}</span>
                </a>
                <a href="#{# {{ url_for('user.followed_by', username=user.username) }} #}">
                    关注人数：<span class="badge">{{ user.followed.count() }}</span>
                </a>
                {% if current_user.is_authenticated and user != current_user and user.is_following(current_user) %}
                | <span class="label label-default">该用户关注了你</span>
                {% endif %}
            </p>
        </div>
        {% if current_user.is_administrator() %}
        <p>
            <a class="btn bg-danger" href="{{ url_for('user.edit_admin', id=user.id) }}">编辑此用户</a>
        </p>
        {% endif %}
    </div>
</div>
<div>
    <h3>博客动态：</h3>
    {% include '_timeline.html' %}'
    <div class="pagination">
        {{ macros.pagination_widget(pagination, 'main.index') }}
    </div>
</div>
{% endblock %}